#!/bin/sh
# USAGE: ./smb_browser_refresh.sh <smb config file path> <mount path> <username> <password>"
# NOTE: use only absoulte paths (not relative)
#       smb config file path: smb.conf location
# mount path: where to create server directories.
#             NOTE: all the contant of the directory will be DELETED!.
# username: network username (optional)
# password: network password (optional)

smb_conf=$1
mnt_path=$2
username=$3
password=$4

echo "smb: clean mount directory"
nls on
rmdir $mnt_path/*/*/* 2> /dev/null
rmdir $mnt_path/*/* 2> /dev/null
rmdir $mnt_path/* 2> /dev/null
nls off
if [ -f /tmp/runbootapps.env ]; then
   grep " SMB_F_SHARE="    /tmp/runbootapps.env  > /tmp/smb-forced
   grep " WORKGROUP="      /tmp/runbootapps.env >> /tmp/smb-forced
   grep " SMB_COMP_NAME="  /tmp/runbootapps.env >> /tmp/smb-forced
   grep " SMB_SHARE_NAME=" /tmp/runbootapps.env >> /tmp/smb-forced
   if [ -s /tmp/smb-forced ]; then
      . /tmp/smb-forced ; rm /tmp/smb-forced
      if [ "$SMB_F_SHARE" = "YES" -a -n "$WORKGROUP" -a -n "$SMB_COMP_NAME" -a -n "$SMB_SHARE_NAME" ]; then
          mkdir -p /tmp/devices/smb/$WORKGROUP/$SMB_COMP_NAME/$SMB_SHARE_NAME
      fi
   fi
fi

if [ -z "$username" ]; then
   params="-N"
else
   params="-U $username%$password"
fi

echo "smb: locating samba servers and shares, please wait..."
smbtree -b -d0 $params -z $mnt_path
self_wg=`grep "workgroup" /etc/samba/smb.conf|cut -d '=' -f2|sed 's| ||g'|tr a-z A-Z`
self_host=`grep "netbios name" /etc/samba/smb.conf|cut -d '=' -f2|sed 's| ||g'|tr a-z A-Z`
[ -n "$self_wg" -a -n "$self_host" ] && rm -rf $mnt_path/$self_wg/$self_host
echo "smb: finished locating shares!"
